//
// Created by kgrug on 23.10.2020.
//

#include "testlib.h"
#include <string>

using namespace std;

int main(int argc, char* argv[])
{
    registerValidation(argc, argv);

    int n = inf.readInt(1, 1e5, "n");

    inf.readEoln();

    int prevt = -1;
    for (int i = 0; i < n; i++) {
        string s = inf.readToken("[0-9][0-9]:[0-9][0-9]", "s");

        int hh = stoi(s.substr(0, 2));
        ensuref(hh >= 0 && hh <= 4, "expected: hh between 0 and 4, got %d", hh);
        ensuref(s[2] == ':', "expected \":\", got %c", s[2]);
        int mm = stoi(s.substr(3, 2));
        ensuref(mm >= 0 && mm < 60, "expected: mm between 0 and 59, got %d", mm);

        int ct = hh * 60 + mm;

        ensuref(prevt <= ct, "time of submits should be non-decreasing");
        
        prevt = ct;

        inf.readSpace();

        string task = inf.readToken("[A-Z]", "task");

        inf.readSpace();

        string verdict = inf.readToken("OK|TL|ML|WA|RE|CE|SV", "verdict");

        inf.readEoln();
    }

    inf.readEof();
}