#include "testlib.h"
#include <iostream>

using namespace std;

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    int n = atoi(argv[1]);
    int m = atoi(argv[2]);
    int k = atoi(argv[3]);
    int prob = atoi(argv[4]);
    vector<int> go = {-1, 0, 1, 0, 0, -1, 0, 1};
    int x1, y1, x2, y2;
    cout << n << " " << m << " " << k << endl;
    set<pair<pair<int, int>, pair<int, int>>> graph;
    if (k == 2 * n * m - m - n) {
        for (int i = 0; i < n - 1; i++) {
            for (int j = 0; j < m; j++) {
                cout << i + 1 << " " << j + 1 << " " << i + 2 << " " << j + 1 << endl;
            }
        }
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m - 1; j++) {
                cout << i + 1 << " " << j + 1 << " " << i + 1 << " " << j + 2 << endl;
            }
        }
    } else {
        for (int i = 0; i < k; i++) {
            do {
                x1 = rnd.next(0, prob * n / 100);
                y1 = rnd.next(0, prob * m / 100);
                do {
                    int x = rnd.next(0, 3);
                    x2 = x1 + go[2 * x];
                    y2 = y1 + go[2 * x + 1];
                } while (x2 < 0 || y2 < 0 || x2 >= n || y2 >= m);
                if (x1 < x2 || y1 < y2) {
                    swap(x1, x2);
                    swap(y1, y2);
                }
            } while (graph.count({{x1, y1}, {x2, y2}}));
            cout << x1 + 1 << " " << y1 + 1 << " " << x2 + 1 << " " << y2 + 1 << endl; 
            graph.insert({{x1, y1}, {x2, y2}});
        }
    }
    int l = rnd.next(15, 20);
    cout << l << endl;
    cout << n << " " << m << endl;
    for (int i = 1; i < l; i++) {
        x1 = rnd.next(0, n - 1);
        y1 = rnd.next(0, m - 1);
        cout << x1 + 1 << " " << y1 + 1 << endl;
    }
}
