
#include <bits/stdc++.h>
using namespace std;

int n, m, k;
map<pair<int, int>, vector<pair<int, int>>> graph;
vector<vector<int> > dp;

int main() {
    cin >> n >> m >> k;
    for (int i = 0; i < k; i++) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        --x1; --y1; --x2; --y2;
        if (x1 > x2 || y1 > y2) {
            swap(x1, x2);
            swap(y1, y2);
        }
        if (graph.count({x1, y1}) == 0 ) {
            graph[make_pair(x1, y1)] = {{x2, y2}};
        } else {
            graph[{x1, y1}].push_back({x2, y2});
        }
    }
    dp.resize(n);
    for (int i = 0; i < n; i++) {
        dp[i].resize(m);
    }
    dp[0][0] = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            for (auto l : graph[make_pair(i, j)]) {
                dp[l.first][l.second] = max(dp[l.first][l.second], dp[i][j] + 1);
            }
            if (i < n - 1) {
                dp[i + 1][j] = max(dp[i + 1][j], dp[i][j]);
            }
            if (j < m - 1) {
                dp[i][j + 1] = max(dp[i][j + 1], dp[i][j]);
            }
        }
    }
    int pep;
    cin >> pep;
    for (int i = 0; i < pep; i++) {
        int x, y;
        cin >> x >> y;
        --x; --y;
        int dist = (x + y + 1) / 2;
        int x1 = x;
        int y1 = dist - x;
        if (y1 < 0) {
            x1 = dist;
            y1 = 0;
        }
        int maxim = dp[x1][y1];
        while (y1 <= y && x1 >= 0) {
            maxim = max(maxim, dp[x1][y1]);
            x1 -= 1;
            y1 += 1;
        }
        cout << maxim << endl;
    }
}

//3 5
//4
//0 0 1 0
//1 1 1 2
//1 3 2 3
//1 3 1 4
//10
//1 1