// Generator created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;

const ll MAXV = 1'000'000'000'000'000'000;
const int MAXX = 1'000'000'000;

const int L = 6, base = 30, mask = (1 << base) - 1;

struct big_int {
    int num[L];
    big_int() {
        memset(num, 0, sizeof num);
    }
    big_int(ll x) {
        memset(num, 0, sizeof num);
        num[0] = x & mask;
        num[1] = x >> base;
    }

    big_int operator*(big_int const& other) const {
        big_int ret;
        for (int i = 0; i < L; ++i) {
            ll carry = 0;
            for (int j = i; j < L; ++j) {
                carry += (ll) num[i] * other.num[j - i];
                carry += ret.num[j];
                ret.num[j] = carry & mask;
                carry >>= base;
            }
        }
        return ret;
    }

    bool operator<(big_int const& other) const {
        for (int i = L - 1; i >= 0; --i) {
            if (num[i] != other.num[i]) {
                return num[i] < other.num[i];
            }
        }
        return false;
    }

    bool operator>(big_int const& other) const {
        return other.operator<(*this);
    }

    bool operator<=(big_int const& other) const {
        return !(operator>(other));
    }
};

ll calc(ll a, ll b) {
    ll ret = sqrt((long double) a * b);
    big_int p = (big_int) a * (big_int) b;
    while ((big_int) ret * (big_int) ret > p) {
        --ret;
    }
    while ((big_int) (ret + 1) * (big_int) (ret + 1) <= p) {
        ++ret;
    }

    return ret;
}


int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	int n = opt<int>(1);

	cout << n << "\n";
	for (int i = 0; i < n; ++i) {
		ll a = rnd.next(1ll, MAXV);
		ll b = rnd.next(1ll, (ll) MAXX * MAXX / a);
		ll c = rnd.next(1ll, (ll) MAXX * MAXX / a);
		vector<ll> arr = {calc(a, b), calc(a, c), calc(b, c)};
		shuffle(arr.begin(), arr.end());
		bool ok = true;
		for (auto num : arr) {
			if (num > MAXX) {
				ok = false;
				break;
			}
		}
		if (!ok) {
			--i;
			continue;
		}
		cout << arr[0] << " " << arr[1] << " " << arr[2] << "\n";
	}

	return 0;
}