#include "testlib.h"
#include <cmath>
#include <vector>
#include <random>

using namespace std;

int main(int argc, char *argv[]) {

    registerGen(argc, argv, 1);

    int n = atoi(argv[1]);
    long long from = atoi(argv[2]), to = atoi(argv[3]), low = atoi(argv[4]);

    println(n);
    for (int i = 0; i < n; i++) {
        long long rnd1 = rnd.next(from, to), rnd2 = rnd.next(from, to);

        vector<long long> values{
                static_cast<long long>(floorl(sqrtl(low * rnd1))),
                static_cast<long long>(floorl(sqrtl(low * rnd2))),
                static_cast<long long>(floorl(sqrtl(rnd1 * rnd2)))
        };
        std::shuffle(values.begin(), values.end(), mt19937(random_device()()));

        println(values[0], values[1], values[2]);
    }

}