// Generator created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;

struct point {
	int x, y;
	point() {}
	point(int _x, int _y) : x(_x), y(_y) {}

	point operator-(point const& other) const {
		return point(x - other.x, y - other.y);
	}

	point operator+(point const& other) const {
		return point(x + other.x, y + other.y);
	}
};

int cross(point const& p1, point const& p2) {
	return p1.x * p2.y - p1.y * p2.x;
}

int dot(point const& p1, point const& p2) {
	return p1.x * p2.x + p1.y * p2.y;
}


int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	int t = opt<int>(1);
	int minn = opt<int>(2);
	int maxn = opt<int>(3);

	cout << t << "\n";

	for (int tn = 1; tn <= t; ++tn) {
		int n = rnd.next(minn, maxn);
		vector<point> sides;
		for (int x = -20; x <= -1; ++x) {
			for (int y = 1; y <= 20; ++y) {
				if (__gcd(abs(x), abs(y)) == 1) {
					sides.push_back(point(x, y));
				}
			}
		}

		shuffle(sides.begin(), sides.end());
		sides.resize(n - 3);
		point vec = point(-rnd.next(1400, 1500), rnd.next(1400, 1500));
		for (auto p : sides) {
			vec = vec - p;
		}
		sides.push_back(vec);
		sort(sides.begin(), sides.end(), [&](auto& a, auto& b) {
			return cross(a, b) > 0;
		});

		bool ok = true;
		for (int i = 0; i < szof(sides) - 1; ++i) {
			if (cross(sides[i], sides[i + 1]) == 0) {
				ok = false;
				break;
			}
		}

		if (!ok) {
			--tn;
			continue;
		}

		vector<point> poly = {point(1000, -500)};
		for (auto v : sides) {
			poly.push_back(poly.back() + v);
		}
		poly.push_back(point(rnd.next(-1000, -500), rnd.next(-1000, -500)));
		cout << n << "\n";
		for (auto p : poly) {
			cout << p.x << " " << p.y << "\n";
		}

	}

	return 0;
}