// Generator created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;

const int MAXC = 1000;

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	int t;
	cin >> t;
	cout << t << "\n";

	for (int tn = 1; tn <= t; ++tn) {
		int n;
		cin >> n;
		vector<pii> poly;
		int minx = INF, maxx = -INF, miny = INF, maxy = -INF;
		for (int i = 0; i < n; ++i) {
			int x, y;
			cin >> x >> y;
			minx = min(minx, x);
			maxx = max(maxx, x);
			miny = min(miny, y);
			maxy = max(maxy, y);
			poly.push_back({x, y});
		}

		int shiftx = rnd.next(-MAXC - minx, MAXC - maxx);
		int shifty = rnd.next(-MAXC - miny, MAXC - maxy);

		for (auto& p : poly) {
			p.ff += shiftx;
			p.ss += shifty;
		}

		int r = rnd.next(0, 3);
		for (int i = 0; i < r; ++i) {
			for (auto& p : poly) {
				swap(p.ff, p.ss);
				p.ff *= -1;
			}
		}

		rotate(poly.begin(), poly.begin() + rnd.next(0, n - 1), poly.end());

		cout << n << "\n";
		for (auto p : poly) {
			cout << p.ff << " " << p.ss << "\n";
		}
	}

	return 0;
}