//
// Created by kgrug on 23.10.2020.
//

#include <iostream>
#include <vector>
#include <string>

using namespace std;

int main() {
    int n;
    cin >> n;

    constexpr int alphabetSize = 26;

    vector<int> penalty(alphabetSize);
    vector<bool> pass(alphabetSize);

    for (int i = 0; i < n; i++) {
        char task;
        string s, verdict;
        cin >> s >> task >> verdict;

        int indTask = task - 'A';

        int hh = stoi(s.substr(0, 2));
        int mm = stoi(s.substr(3, 2));

        if (!pass[indTask] && verdict == "OK") {
            pass[indTask] = true;
            penalty[indTask] += hh * 60 + mm;
        }

        if (!pass[indTask] && verdict != "CE") {
            penalty[indTask] += 20;
        }
    }

    int passedCount = 0, totalPenalty = 0;

    for (int i = 0; i < alphabetSize; i++) {
        if (pass[i]) {
            passedCount++;
            totalPenalty += penalty[i];
        }
    }

    cout << passedCount << " " << totalPenalty;

    return 0;
}