#include "testlib.h"

using namespace std;

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);

    for (int i = 0; i < 2; ++i) {
        string s = inf.readToken("[\\|\\.]{1,100}", format("s[%d]", i + 1));
        inf.readEoln();

        int l = 0;
        int r = 0;
        bool was = false;
        for (char c : s) {
            if (c == '.') {
                if (!was) {
                    ++l;
                } else {
                    ++r;
                }
            } else if (c == '|') {
                ensuref(!was, "more than one | in string");
                was = true;
            } else {
                ensuref(false, "unexpected character: %c", c);
            }
        }
        ensuref(was, "no | in string");
        ensuref(l <= 6 && r <= 6, "too many dots in one half");
    }

    inf.readEof();

    return 0;
}
