#include <iostream>
#include <string>
#include <vector>
#include <limits>
#include <unordered_set>

using namespace std;

int main() {

    unsigned int n;
    cin >> n;

    vector<string> names(n);
    string res;
    vector<int> positions;

    unsigned int min_length = numeric_limits<unsigned int>::max();
    for (unsigned int i = 0; i < n; i++) {
        cin >> names[i];
        res += names[i];
        res += names[i];
        res += '$';
        for (unsigned int t = 0; t < 2 * names[i].size(); t++) {
            positions.push_back(i);
        }
        positions.push_back(-1);
        min_length = min(min_length, names[i].size());
    }

    unsigned int l = res.size();
    vector<unsigned int> p(l), c(l), count('z' - 'a' + 2);
    for (char x : res) {
        count[max(0, x - 'a' + 1)]++;
    }
    for (unsigned int i = 1; i <= 'z' - 'a' + 1; i++) {
        count[i] += count[i - 1];
    }
    for (unsigned int i = 0; i < l; i++) {
        p[--count[max(0, res[i] - 'a' + 1)]] = i;
    }

    int cls = 0;
    c[p[0]] = cls;
    for (unsigned int i = 1; i < l; i++) {
        if (res[p[i]] != res[p[i - 1]]) {
            cls++;
        }
        c[p[i]] = cls;
    }
    vector<unsigned int> pp(l);
    vector<unsigned int> cc(l);

    for (unsigned int pow = 0; (1u << pow) < l; pow++) {
        for (unsigned int i = 0; i < l; i++) {
            pp[i] = (p[i] - (1u << pow) + l) % l;
        }

        count.assign(cls + 1, 0);
        for (unsigned int i = 0; i < l; i++) {
            count[c[pp[i]]]++;
        }
        for (unsigned int i = 1; i <= cls; i++) {
            count[i] += count[i - 1];
        }
        for (int i = l - 1; i >= 0; i--) {
            p[--count[c[pp[i]]]] = pp[i];
        }

        cls = 0;
        cc[p[0]] = cls;
        for (unsigned int i = 1; i < l; i++) {
            unsigned int m1 = (p[i] + (1u << pow)) % l;
            unsigned int m2 = (p[i - 1] + (1u << pow)) % l;
            if (c[p[i]] != c[p[i - 1]] || c[m1] != c[m2]) {
                cls++;
            }
            cc[p[i]] = cls;
        }

        for (unsigned int i = 0; i < l; i++) {
            c[i] = cc[i];
        };
    }

    vector<unsigned int> lcp(l), pos(l);
    for (unsigned int i = 0; i < l; i++) {
        pos[p[i]] = i;
    }
    int k = 0;
    for (int i = 0; i < l; ++i) {
        if (k > 0) {
            --k;
        }
        if (pos[i] == l - 1) {
            lcp[l - 1] = -1;
            k = 0;
            continue;
        } else {
            int j = p[pos[i] + 1];
            while (max(i + k, j + k) < l && res[i + k] == res[j + k]) {
                ++k;
            }
            lcp[pos[i]] = k;
        }
    }

    unsigned int left = 0, right = min_length + 1;
    while (right - left > 1) {
        unsigned int mid = (left + right) / 2;
        bool found = false;

        unordered_set<int> strings;
        unsigned int i = 0;
        while (i < l) {
            if (positions[p[i]] != -1) {
                strings.insert(positions[p[i]]);
            }
            while (i + 1 < l && lcp[i] >= mid) {
                i++;
                if (positions[p[i]] != -1) {
                    strings.insert(positions[p[i]]);
                }
            }
            if (strings.size() == n) {
                found = true;
            }

            strings.clear();
            i++;
            if (found) {
                break;
            }
        }

        if (found) {
            left = mid;
        } else {
            right = mid;
        }
    }

    std::cout << left << '\n';
/*
    unordered_set<int> strings;
    unsigned int i = 0;
    int start = -1;
    while (i < l) {
        int from = i;
        if (positions[p[i]] != -1) {
            strings.insert(positions[p[i]]);
        }
        while (i + 1 < l && lcp[i] >= left) {
            i++;
            if (positions[p[i]] != -1) {
                strings.insert(positions[p[i]]);
            }
        }
        if (strings.size() == n) {
            start = from;
            break;
        }

        strings.clear();
        i++;
    }

    if (start > -1) {
        for (unsigned int t = p[start]; t < p[start] + left; t++) {
            cout << res[t];
        }
    }
    cout << '\n';*/

}