#include <iostream>
#include <string>
#include <vector>
#include <limits>
#include <unordered_set>

using namespace std;

int main() {

    unsigned int n;
    cin >> n;

    vector<string> names(n);
    string res;
    vector<int> positions;

    unsigned int min_length = numeric_limits<unsigned int>::max();
    for (unsigned int i = 0; i < n; i++) {
        cin >> names[i];
        res += names[i];
        res += names[i];
        res += '$';
        for (unsigned int t = 0; t < 2 * names[i].size(); t++) {
            positions.push_back(i);
        }
        positions.push_back(-1);
        min_length = min(min_length, names[i].size());
    }

    unsigned int l = res.size();
    unsigned int ans = 0, from = 0;

    for (unsigned int start = 0; start < names[0].size(); start++) {
        vector<unsigned int> pref(l - start);
        vector<unsigned int> max_match(n);
        max_match[0] = names[0].size();

        for (unsigned int i = 1; i < l - start; i++) {
            unsigned int q = pref[i - 1];
            while (q > 0 && res[start + i] != res[start + q]) {
                q = pref[q - 1];
            }
            if (res[start + i] == res[start + q]) {
                q++;
            }
            pref[i] = q;

            unsigned int str = positions[start + i];
            if (str != -1) {
                max_match[str] = max(max_match[str], pref[i]);
            }
        }

        unsigned int mn = max_match[0];
        for (unsigned int i = 1; i < n; i++) {
            mn = min(mn, max_match[i]);
        }
        if (mn > ans) {
            ans = mn;
            from = start;
        }
    }

    /*for (unsigned int i = from; i < from + ans; i++) {
        std::cout << res[i];
    }*/

    cout << ans << '\n';

}