def search(am, v, k, l):
	if len(v) < k and len(v) < l:
		return []
	main_vertex = v[0]
	if k == 1:
		return [[main_vertex], 0]
	if l == 1:
		return [[main_vertex], 1]
	v_clique = []
	v_anticlique = []
	for i in range(1, len(v)):
		if am[main_vertex][v[i]]:
			v_clique.append(v[i])
		else:
			v_anticlique.append(v[i])
	clique_ans = search(am, v_clique, k, l - 1)
	if len(clique_ans) > 0:
		if clique_ans[1] == 1:
			clique_ans[0].append(main_vertex)
		return clique_ans
	anticlique_ans = search(am, v_anticlique, k - 1, l)
	if len(anticlique_ans) > 0:
		if anticlique_ans[1] == 0:
			anticlique_ans[0].append(main_vertex)
		return anticlique_ans
	v.pop(0)
	return search(am, v, k, l)


n, m, k, l = map(int, input().split())
n = min(n, 43)
am = [[False for i in range(n)] for j in range(n)]
for i in range(m):
	a, b = map(int, input().split())
	a -= 1
	b -= 1
	if a < n and b < n:
		am[a][b] = True
		am[b][a] = True
v = list(range(n))
w = search(am, v, k, l)
if len(w) > 0:
	w = w[0]
	w.sort()
	for i in range(len(w)):
		w[i] += 1;
	print(*w)
else:
	print(-1)
